using System;
using System.Text.RegularExpressions;

public class ExpReg {
public static void Main()
{
  string chaine = "Fourmond:Sophie:07-28-2004:"+
    "02-14-2005:";
  Console.WriteLine("Chaine initiale: " +chaine);
  // On compile l'expression reguliere date
  Regex date = new 
    Regex("(\\d{2})-(\\d{2})-(\\d{4})");
  // On verifie si la chaine contient des dates:
  if(! date.IsMatch(chaine)) 
    Console.WriteLine("Pas de dates !");
  // On initialise la boucle
  Match m = date.Match(chaine);
  while(m.Success) {
    Console.WriteLine("Date trouvee: " +
       m.Groups[0] + "\nAnnee: "+ m.Groups[3]);
    m = m.NextMatch();
  }
  // On effectue le remplacement:
  string chaineF=date.Replace(chaine,"$2.$1.$3");
  Console.WriteLine("Chaine finale: "+ chaineF);
}
}
